# High-level Repository Description
This Repository will contain the code needed to implement modified oGFisher statistical analysis using distributed computation supported by Spark on Hail. Potential implementaions will utilize Pandas on Spark, Spark clusters, and existing Hail statistics functions. 

All the code contained here for functionality is consistent with the code provided in both R and Python. We need to rewrite the code such that it does not use Numpy as the library does not support distributed computation and thus such an implementaion defeats the purpose of rewriting the code as it will not be scallable to big data we are using in Terra.

## Overarching Idea and Approach
In this approach we will only rely on the modified algorithm implementations needed for basic matrix calculations. Thus, we need to find existing implementations or descriptions of basic matrix calculations such that ours can be converted into those to assure proper and scallable processing. 

More specifically, we will utilize Hail to process vcf file into a Hail matrix which can later be converted into a Spark structure, if necessary. After, we will utilize existing distriuted algorithm implementations and modify our matrix operations to be consistent with the data structures. 

## Resrouces and Core Algorithm Implementations
Convert Hail matrix into a Spark matrix [to_spark](https://hail.is/docs/0.2/hail.Table.html#hail.Table.to_spark)
Usage of Pandas for big data processing [pandas for big data](https://towardsdatascience.com/how-to-use-pandas-for-big-data-50650945b5c6)
Matrix multiplication [spark RDD implementation](https://stackoverflow.com/questions/33558755/matrix-multiplication-in-apache-spark)
See more included code for basic matrix operations using pyspark


