'''
this file contains informatio non how to create a hail matrix table, convert it into a pySpark Pandas table and perform some calculations on it
note: for testing purposes an existing Hail table ht.mt (in this repository) was used to compare the accuracy of calculations based on Hail's functions and PySparks Functions
Moreover, we also compare the computational speed of Hail and PySpark given the same calculations
Finally, in order to use PySpark Pandas and Hail in the same kernel/machine old versions of libraries need to installed which would slow down computations and can causes errors/failures in the future
For larger data sets, make sure to start two different clusters with two different versions of Spark for Hail adn PySpark Pandas, the two clusters will communicate via passing the data/files to one another
'''

import time
import hail as hl
import pyspark.pandas as ps # we can also use pyspark sql, it would be a good option if data filtration is needed
#for computations, pyspark pandas would be more optimal since there are many more implemented calculations
hl.init(log="connectHailSpark.log")
ht = hl.read_table("../hailMatrices/ht.mt") #make sure to be in the correct directory from which this file is visible to the program
#perform standard deviation calculation using Hail
startHail = time.time()
std = hl.agg.stats(hl.agg.stats(ht.weight_take.collect()).stdev)
endHail = time.time()
print(endHail - startHail)
#use pyspark 3.3.4 -> use that version since it seems to be compatible with Hail
#hail version 0.2.129
#apache spark 3.3.4
#openjdk 11.0.22 or maybe the 8 version
#version of pandas 2.2.1
#pyspark 3.3.4
# #java version check and scala version check make sure to specify which ones work with one another