'''
attempted version to rewrite the p_GFisher function using only Hail built in tools
'''

#new proposed version which will only use Hail and Spark libraries
import hail as hl
from hail.linalg import BlockMatrix
'''
code does not work at all but this is somewhat of a start in the direction that we need to move in
'''


def getGFisherlam():
    pass

def getGFisherGM():
    pass
def p_GFisher(q, df, w, M, p_type="two", method="HYB", nsim=None, seed=None):
    """
    Calculates p-value using Fisher's exact test with various methods.

    Args:
        q: Test statistic (float).
        df: Degrees of freedom (array-like of ints).
        w: Weights for observations (array-like of floats).
        M: correlation matrix of the Zscores from which the input p-values were obtained.
        p_type: Tail of the test ("two" for two-sided, other for one-sided).
        method: Method for calculating p-value ("MR" for Monte Carlo, "HYB" for hybrid, "Brown" for Brown's method).
        nsim: Number of simulations for Monte Carlo method (int, default=None).
        seed: Random seed for Monte Carlo simulation (int, default=None).

    Returns:
        The calculated p-value (float).
    """
    n = M.shape[1]  # Number of columns in contingency table

    # Assure that the function runs with arrays and constants; constants will be turned into arrays of repeating values of the given constant
    if isinstance(df, int) or isinstance(df, float):
        df = hl.ones(n) * df
    if isinstance(w, int) or isinstance(w, float):
        w = hl.ones(n) * w

    # Normalize weights
    w = hl.experimental.array_sum(w) / hl.experimental.array_sum(hl.ones(n))

    if method == "MR":
        # Monte Carlo simulation method (MR)
        nsim = int(nsim)
        # Convert M to a BlockMatrix
        M_bm = BlockMatrix.from_numpy(M)
        # Generate random data
        hl.set_seed(seed)
        znull = hl.random.randn(nsim, n) @ M_bm
        if p_type == "two":
            pnull = 2 * hl.experimental.linalg.norm_cdf(-hl.abs(znull))
        else:
            pnull = hl.experimental.linalg.norm_cdf(znull, loc=0, scale=1, lower_tail=False)
        if hl.stddev(df) == 0:
            if df.all() == 2:
                pp_trans = -2 * hl.log(pnull)
            else:
                pp_trans = chi_squared_tail(df[0], 1 - pnull)
        else:
            pp_trans = hl.map(lambda x: chi_squared_tail(x), pnull)
        fishernull = hl.experimental.array_sum(pp_trans * w, axis=1)
        MM = hl.map(lambda x: hl.mean(fishernull ** x), hl.range(1, 5))
        mu = MM[0]
        sigma2 = (MM[1] - MM[0] ** 2) * nsim / (nsim - 1)
        cmu3 = MM[2] - 3 * MM[1] * MM[0] + 2 * MM[0] ** 3
        cmu4 = MM[3] - 4 * MM[2] * MM[0] + 6 * MM[1] * MM[0] ** 2 - 3 * MM[0] ** 4
        gm = cmu3 / sigma2 ** (3 / 2)
        kp = cmu4 / sigma2 ** 2 + 3
        a = 9 * gm ** 2 / (kp - 3) ** 2
        pval = gamma_tail((q - mu) / hl.sqrt(sigma2) * hl.sqrt(a) + a, a=a, scale=1)
    else:
        # Hybrid and Brown's methods
        GM = getGFisherGM(df, w, M, p_type)
        mu = hl.experimental.array_sum(w * df)
        sigma2 = hl.experimental.array_sum(GM)
        if method == "HYB":
            # Hybrid method
            out_GM = getGFisherlam(df, w, M, GM, p_type)
            lam = out_GM["lam"]
            c2 = hl.experimental.array_sum(lam**2)
            c3 = hl.experimental.array_sum(lam**3)
            c4 = hl.experimental.array_sum(lam**4)
            gm = hl.sqrt(8) * c3 / c2**(3/2)
            kp = 12 * c4 / c2**2 + 3
        else:
            # Brown's method
            a = mu**2 / sigma2

        a = 9 * gm**2 / ((kp - 3)**2)
        pval = 1 - norm.cdf(q, loc=mu, scale=hl.sqrt(abs(sigma2)) * hl.sqrt(a))
        if p_type == "two":
            pval = 2 * hl.min(pval, 1 - pval)

    return pval