#TODO: clean up the code such that if any of the seconds are uncommented they can all be ran simultaneously
import vcf
import time
import hail as hl
import numpy as np
from scipy.stats import tstd
from scipy.stats import describe
import pandas as pd
import pyspark.pandas as ps

##########################vcf file processing
'''
startTime = time.time()
ds = hl.import_vcf('/home/taya/Downloads/condensed_vcf_files_chr21_filtered_50samples_sn.vcf', reference_genome='GRCh37')
endTime = time.time()
# print the difference between start
# and end time in milli. secs
print("The time of execution of above program is :",
      (endTime - startTime) * 10**3, "ms")
'''

####################hail matrix used for calculations
'''
mt = hl.balding_nichols_model(1, n_samples=100, n_variants=20)
mt = mt.annotate_rows(gene = mt.locus.position // 12)
mt = mt.annotate_rows(weight = 1)
mt = mt.annotate_cols(phenotype = hl.agg.sum(mt.GT.n_alt_alleles()) - 20 + hl.rand_norm(0, 1))
mt.describe()
mt.show()
'''

#standard deviation calculation using numpy, pandas and scipy all timed, all on matrices of increasingly larger size
#use of numpy to create all the matrices as it is usniversal for the 2 libraries, then convert to pandas as necesary
#10by10 matrix of random numbers from 1:100
m1 = np.random.randint(1, 101, size=(10, 10)) #10 to hthe first power size m1
m2 = np.random.randint(1, 101, size=(100, 100))
m3 = np.random.randint(1, 101, size=(1000, 1000))
m4 = np.random.randint(1, 101, size=(10000, 10000))
#m5 = np.random.randint(1, 101, size=(100000, 100000)) #Unable to allocate 74.5 GiB for an array with shape (100000, 100000) and data type int64
#TODO: unable to allocate memory issue for 100k by 100k matrix
'''
#now calculate the standard deviation for all of them and record how long it takes using numpy
start1 = time.time()
print(np.std(m1))
end1 = time.time()
print(end1 - start1)

start2 = time.time()
print(np.std(m2))
end2 = time.time()
print(end2 - start2)

start3 = time.time()
print(np.std(m3))
end3 = time.time()
print(end3 - start3)

start4 = time.time()
print(np.std(m4))
end4 = time.time()
print(end4 - start4)
'''

#now for scipy we use trimmed standard deviation; still using the same randomly generate numpy arrays
'''
start1 = time.time()
print(tstd(m1))
end1 = time.time()
print(end1 - start1)

start2 = time.time()
print(tstd(m2))
end2 = time.time()
print(end2 - start2)

start3 = time.time()
print(tstd(m3))
end3 = time.time()
print(end3 - start3)

start4 = time.time()
print(tstd(m4))
end4 = time.time()
print(end4 - start4)
'''

#now scipy regual standard deviation calculation; it calculates a lot more than just std

'''
start1 = time.time()
_, _, _, _, std_deviation, _ = describe(m1)
print(std_deviation)
end1 = time.time()
print(end1 - start1)

start2 = time.time()
_, _, _, _, std_deviation, _ = describe(m2)
print(std_deviation)
end2 = time.time()
print(end2 - start2)

start3 = time.time()
_, _, _, _, std_deviation, _ = describe(m3)
print(std_deviation)
end3 = time.time()
print(end3 - start3)

start4 = time.time()
_, _, _, _, std_deviation, _ = describe(m4)
print(std_deviation)
end4 = time.time()
print(end4 - start4)
'''

#pandas standard deviation using stacking so similar to what numpy does
'''
df1 = pd.DataFrame(m1)
df2 = pd.DataFrame(m2)
df3 = pd.DataFrame(m3)
df4 = pd.DataFrame(m4)


start1 = time.time()
print(df1.stack().std())
end1 = time.time()
print(end1 - start1)

start1 = time.time()
print(df2.stack().std()) 
end1 = time.time()
print(end1 - start1)

start1 = time.time()
print(df3.stack().std())
end1 = time.time()
print(end1 - start1)

start1 = time.time()
print(df4.stack().std())
end1 = time.time()
print(end1 - start1)

'''
#now perform all the calculation using pandas for standard deviation
#pandas standard deviation for each of the columns so similar to what scipy and spark would do


'''
start1 = time.time()
print(df1.std())
end1 = time.time()
print(end1 - start1)

start1 = time.time()
print(df2.std())
end1 = time.time()
print(end1 - start1)
'''

#now pandas standard deviation using pyspark pandas  with one cluster
#make sure to specify here that we want to use the later version of spark if possible because otherwise this is not optimal
#make sure to specify the versions of everything used in the project
df1 = ps.DataFrame(m1)
df2 = ps.DataFrame(m2)
df3 = ps.DataFrame(m3)
df4 = ps.DataFrame(m4)


start1 = time.time()
print(df1.std())
end1 = time.time()
print(end1 - start1)





