'''
experimental file -> ignore
'''
# Step 1: Import required libraries
from pyspark.sql import SparkSession
from pyspark.sql.types import StructType, StructField, FloatType

# Step 2: Create a SparkSession
spark = SparkSession.builder \
    .appName("example") \
    .getOrCreate()

# Step 3: Define the schema for your DataFrame
schema = StructType([
    StructField("value", FloatType(), nullable=False)
])

# Step 4: Create an RDD from the array
array = [63.67454620472518, 62.33768758539941]
rdd = spark.sparkContext.parallelize(array)

# Step 5: Convert the RDD into a DataFrame using the defined schema
df = spark.createDataFrame(rdd.map(lambda x: (float(x),)), schema)

# Show the DataFrame
df.show()