#TODO: include other ways of calculating nearPD and explain the differences via examples
'''
The calculations below are for finding the nearest positive definite matrix
which is necessary in pValue calculations procided by p_GFisher using numpy
'''
from numpy import linalg as la
import numpy as np
class NPD:
    '''
    """
Created on Sun Dec  3 15:55:26 2017
@author: https://gist.github.com/fasiha/fdb5cec2054e6f1c6ae35476045a0bbd
Directory Link: https://github.com/alan-turing-institute/bocpdms/blob/master/nearestPD.py
"""
    '''

    def isPD(B):
        """Returns true when input is positive-definite, via Cholesky"""
        try:
            _ = la.cholesky(B)
            return True
        except la.LinAlgError:
            return False

    def nearestPD(A):
        """Find the nearest positive-definite matrix to input

        A Python/Numpy port of John D'Errico's `nearestSPD` MATLAB code [1], which
        credits [2].

        [1] https://www.mathworks.com/matlabcentral/fileexchange/42885-nearestspd

        [2] N.J. Higham, "Computing a nearest symmetric positive semidefinite
        matrix" (1988): https://doi.org/10.1016/0024-3795(88)90223-6

        Example usage:
        A = np.array([[2, -1, 0], [-1, 2, -1], [0, -1, 2]])
        nearest_pd_matrix = NPD.nearestPD(A)
        print("Original matrix A:\n", A)
        print("\nNearest positive definite matrix:\n", nearest_pd_matrix)
        print("\nIs nearest_pd_matrix positive definite?", NPD.isPD(nearest_pd_matrix))
        """

        B = (A + A.T) / 2
        _, s, V = la.svd(B)

        H = np.dot(V.T, np.dot(np.diag(s), V))

        A2 = (B + H) / 2

        A3 = (A2 + A2.T) / 2

        if NPD.isPD(A3):
            return A3

        spacing = np.spacing(la.norm(A))
        # The above is different from [1]. It appears that MATLAB's `chol` Cholesky
        # decomposition will accept matrixes with exactly 0-eigenvalue, whereas
        # Numpy's will not. So where [1] uses `eps(mineig)` (where `eps` is Matlab
        # for `np.spacing`), we use the above definition. CAVEAT: our `spacing`
        # will be much larger than [1]'s `eps(mineig)`, since `mineig` is usually on
        # the order of 1e-16, and `eps(1e-16)` is on the order of 1e-34, whereas
        # `spacing` will, for Gaussian random matrixes of small dimension, be on
        # othe order of 1e-16. In practice, both ways converge, as the unit test
        # below suggests.
        I = np.eye(A.shape[0])
        k = 1
        while not NPD.isPD(A3):
            mineig = np.min(np.real(la.eigvals(A3)))
            A3 += I * (-mineig * k ** 2 + spacing)
            k += 1

        return A3

#built in python library
#https://www.statsmodels.org/dev/generated/statsmodels.stats.correlation_tools.cov_nearest.html
#cov = [[1,1], [1,1]]
#print(statsmodels.stats.correlation_tools.cov_nearest(cov, method='clipped', threshold=1e-15, n_fact=100, return_all=False))
