#testing the computational speed of std calculations on larger and larger matrices in R
#use cor or cov -> make these comp; just use the built in one in R and make sure to run it 100 times for the avergae time computation

set.seed(123)
# Create a 10 by 10 matrix with random values from 1 to 100
data1 <- matrix(sample(1:100, 100, replace = TRUE), nrow = 1000, ncol = 1000)
num_iterations <- 100
# Loop to run covariance calculation and record execution times
for (i in 1:num_iterations) {
  start_time <- Sys.time()  # Record start time
  
  # Calculate covariance
  covariance_matrix <- cov(data1)
  
  end_time <- Sys.time()  # Record end time
  
  # Calculate execution time in seconds
  execution_time <- end_time - start_time
  
  # Store execution time in array
  execution_times[i] <- execution_time
}

# Save execution times to a CSV file with a title for the column
output_data <- data.frame(execution_times)
write.csv(output_data, file = "execution_times.csv", row.names = FALSE)

# Display message
cat("Execution times saved to execution_times.csv\n")
